%define oname	hybrid-v35
%define kname	wl

%define _enable_debug_packages	%{nil}
%define debug_package		%{nil}

Summary:	Proprietary driver for Broadcom wireless adapters
Name:		broadcom-wl
Version:	6.30.223.271
Release:	7
Source0:	http://www.broadcom.com/docs/linux_sta/%{oname}-nodebug-pcoem-6_30_223_271.tar.gz
Source1:	http://www.broadcom.com/docs/linux_sta/%{oname}_64-nodebug-pcoem-6_30_223_271.tar.gz
Source3:	%{name}.rpmlintrc
Source4:	Kbuild
Source6:	broadcom-wl-alias.conf
Source7:	README.urpmi
Patch1:		broadcom-wl-6.30.223.271-fix-error-handling.patch
Patch2:		broadcom-wl-6.30.223.248-use-common-iface-name.patch
Patch3:		broadcom-wl-6.30.223.248-disable_timestamps.patch
Patch4:		broadcom-wl-6.30.223.248-claim-only-network-devices-by-broadcom.patch
# The following patches are partially from Debian & Ubuntu, partially 
# from Arch Linux.
Patch8:		broadcom-wl-6.30.223.248-user_ioctl.patch
Patch10:	broadcom-wl-6.30.223.271-set-vars-to-null-when-needed.patch
Patch11:	broadcom-wl-6.30.223.271-rdtscl.patch
Patch12:	broadcom-wl-6.30.223.271-kernel-4.7.patch
Patch13:	broadcom-wl-6.30.223.271-kernel-4.8.patch

License:	Freeware
Group:		System/Kernel and hardware
URL:		http://www.broadcom.com/support/802.11

%description
This package contains the proprietary driver for Broadcom wireless
adapters. The driver supports BCM4312-, BCM4313-, BCM4321-, BCM4322-, 
BCM43224-, BCM43225-, BCM43227- and BCM43228-based hardware.

%package -n dkms-%{name}
Summary:	Kernel module for Broadcom wireless adapters
Group:		System/Kernel and hardware
Requires(post):		dkms
Requires(preun):	dkms

%description -n dkms-%{name}
This package contains the proprietary driver for Broadcom wireless
adapters. The driver supports BCM4312-, BCM4313-, BCM4321-, BCM4322-, 
BCM43224-, BCM43225-, BCM43227- and BCM43228-based hardware.

%prep
%ifarch x86_64
%setup -q -T -c -a1 %{oname}
%else
%setup -q -T -c -a0 %{oname}
%endif

%apply_patches

# The Makefile from the upstream package contains the stuff related to
# WEXT support in the kernel, deprecated quite a while ago. In addition,
# the make rules listed there use `uname -r` in the path to the kernel
# build directory which prevents the user from building the driver for a
# kernel other than the running one.
# A Kbuild file we provide should be free from these issues.
rm -f Makefile
cp -p %{SOURCE4} .

# From the .spec file used in Fedora: convert LICENSE.txt to UTF-8 and
# tidy line endings.
iconv -f iso8859-1 -t UTF8 lib/LICENSE.txt -o lib/LICENSE.txt
sed -i 's/\r$//' lib/LICENSE.txt

%build

%install
# add aliases to force loading wl module for supported devices
install -m755 -d %{buildroot}/etc/modprobe.d/
install -m644 %{SOURCE6} %{buildroot}/etc/modprobe.d

mkdir -p %{buildroot}%{_docdir}/%{name}
install -p -m755 %{SOURCE7} %{buildroot}%{_docdir}/%{name}

# install dkms sources
mkdir -p %{buildroot}%{_usr}/src/%{name}-%{version}-%{release}
cp -R * %{buildroot}%{_usr}/src/%{name}-%{version}-%{release}/
cat > %{buildroot}%{_usr}/src/%{name}-%{version}-%{release}/dkms.conf << EOF
MAKE="make -C \$kernel_source_dir M=\\\$(pwd)"
PACKAGE_NAME=%{name}
PACKAGE_VERSION=%{version}-%{release}
DEST_MODULE_LOCATION=/kernel/3rdparty/%{name}
BUILT_MODULE_NAME=%{kname}
AUTOINSTALL=yes
REMAKE_INITRD=yes
EOF

%post -n dkms-%{name}
set -x
/usr/sbin/dkms --rpm_safe_upgrade add -m %{name} -v %{version}-%{release}

# Build and install the driver for all available kernels that have devel
# files, no matter how these kernels were installed (from RPMs or manually).
# Do not fail the installation of the package if the build fails for some
# kernels, this may happen during testing, etc.
for kk in /lib/modules/*; do
	kk=$(echo $kk | sed 's/^\/lib\/modules\///');
	if test -d "/lib/modules/$kk/build"; then
		/usr/sbin/dkms --rpm_safe_upgrade build -m %{name} -v %{version}-%{release} -k $kk &&
		/usr/sbin/dkms --rpm_safe_upgrade install -m %{name} -v %{version}-%{release} -k $kk || true
	else
		echo "WARNING: No development files for kernel \"$kk\"" > /dev/stderr;
	fi;
done

%preun -n dkms-%{name}
# rmmod can fail (e.g. if the module is not loaded), but it should not stop
# deinstallation.
/sbin/rmmod %{kname} >/dev/null 2>&1 || true
set -x
/usr/sbin/dkms --rpm_safe_upgrade remove -m %{name} -v %{version}-%{release} --all || true

%files -n dkms-%{name}
%defattr(0644,root,root,0755)
%doc lib/LICENSE.txt
%config(noreplace) /etc/modprobe.d/broadcom-wl-alias.conf
%dir %{_usr}/src/%{name}-%{version}-%{release}
%{_usr}/src/%{name}-%{version}-%{release}/*
%{_docdir}/%{name}/README.urpmi


%changelog

* Wed Feb 15 2017 Andrey Bondrov <andrey.bondrov@rosalab.ru> 6.30.223.271-7
- (6a10a9a) MassBuild#1250: Increase release tag

* Wed Nov 16 2016 Evgenii Shatokhin <eugene.shatokhin@rosalab.ru> 6.30.223.271-6
- (1ed2978) Fix the crash of the driver with kernel 4.8.x
- (1ed2978) This commit in the mainline kernel changed the meaning of the last
- (1ed2978) argument passed to cfg80211_scan_done():
- (1ed2978) Commit 1d76250bd34af86c6498fc51e50cab3bfbbeceaa
- (1ed2978) Author: Avraham Stern <avraham.stern@intel.com>
- (1ed2978) Date:   Tue Jul 5 17:10:13 2016 +0300
- (1ed2978) nl80211: support beacon report scanning
- (1ed2978) Added the patch to the driver because otherwise it crashes.

* Wed Aug 24 2016 Evgenii Shatokhin <eugene.shatokhin@rosalab.ru> 6.30.223.271-5
- (9e8524e) Added a patch to support kernel 4.7
- (9e8524e) The patch is from ArchLinux with a few changes from Ubuntu.

* Wed Mar 09 2016 Evgenii Shatokhin <eugene.shatokhin@rosalab.ru> 6.30.223.271-4
- (f408b02) Fixed the build in 32-bit systems with kernel 4.3 or newer
- (f408b02) rdtscl() is not available there, the driver should use rdtsc() instead.

* Mon Dec 28 2015 Evgenii Shatokhin <eugene.shatokhin@rosalab.ru> 6.30.223.271-3
- (a758bf5) Fixed the URL
- (Evgenii Shatokhin: 1a312eb) Release up

* Sat Dec 26 2015 Evgenii Shatokhin <eugene.shatokhin@rosalab.ru> 6.30.223.271-2
- (1c79db1) Use b43+ssb modules for BCM4312 (PCI IDs: 14E4:4315) rather than wl
- (1c79db1) Looks like b43+ssb work better for such WiFi-adapters than wl.
- (1c79db1) http://forum.rosalab.ru/viewtopic.php?f=45&t=6420&p=59715#p59715.
- (Evgenii Shatokhin: 680b0ed) Release up

* Wed Dec 02 2015 Evgenii Shatokhin <eugene.shatokhin@rosalab.ru> 6.30.223.271-1
- (76fe759) Use capital letters in the PCI ID parts of the aliases
- (76fe759) I suspect, lowercase letters are the cause of
- (76fe759) http://bugs.rosalinux.ru/show_bug.cgi?id=6396
- (76fe759) For example:
- (76fe759) modprobe -R pci:v000014E4d000043b1sv1234sd1234bc80sc90i12
- (76fe759) wl
- (76fe759) modprobe -R pci:v000014E4d000043B1sv1234sd1234bc80sc90i12
- (76fe759) bcma
- (Evgenii Shatokhin: 92bc611) Updated to version 6.30.223.271
- (Evgenii Shatokhin: 92bc611) Most significant changes:
- (Evgenii Shatokhin: 92bc611) * Support for the kernel versions up to 4.2 inclusive.

* Thu Apr 30 2015 Eugene Shatokhin <eugene.shatokhin@rosalab.ru> 6.30.223.248-4
- (a2a5c2e) Release up

* Thu Apr 30 2015 Eugene Shatokhin <eugene.shatokhin@rosalab.ru> 6.30.223.248-3
- (bfe705d) Require only the development files for the kernel
- (bfe705d) The kernel itself might not be installed yet when the dkms modules are
- (bfe705d) rebuilt (that is done when kernel-devel is installed).
- (Eugene Shatokhin: b9a8cff) Added a patch to support kernel 4.0
- (Eugene Shatokhin: b9a8cff) The patch is a part of linux-recent.patch from ArchLinux.

* Mon Apr 27 2015 Eugene Shatokhin <eugene.shatokhin@rosalab.ru> 6.30.223.248-2
- (34e7fde) Build and install the driver for all kernels at once
- (34e7fde) Before this commit, the drivers were built and installed automatically
- (34e7fde) for the current kernel when the user installed the dkms-<...> package.
- (34e7fde) This could be inconvenient if the user installed the driver and then
- (34e7fde) rebooted the system to a different kernel. DKMS might have failed to
- (34e7fde) build the driver for that kernel at boot, which lead to problems.
- (34e7fde) Let's build and install the drivers for all kernels available in the
- (34e7fde) system at the moment of package installation (if the kernels have
- (34e7fde) development files, of course).
- (34e7fde) Note that the installation of the package should not fail even if the
- (34e7fde) driver fails to build for some kernels.
- (Eugene Shatokhin: 8163eae) Added more patches to support kernel 3.18 and fix a few more bugs
- (Eugene Shatokhin: 8163eae) The patches are based on those from Debian, Ubuntu and Arch Linux.
- (Eugene Shatokhin: 8163eae) Important changes:
- (Eugene Shatokhin: 8163eae) - support for kernel versions up to 3.18 inclusive;
- (Eugene Shatokhin: 8163eae) - fix crashes when the user tries to access the driver via procfs.

* Tue Oct 28 2014 Eugene Shatokhin <eugene.shatokhin@rosalab.ru> 6.30.223.248-1
- (772589c) Updated to version 6.30.223.248, revisited the patch set

* Tue Oct 28 2014 Eugene Shatokhin <eugene.shatokhin@rosalab.ru> 6.30.223.141-8
- (a5006b5) Added aliases for 4 more devices
- (a5006b5) Readme.txt from http://www.broadcom.com/support/802.11/linux_sta.php
- (a5006b5) states the following devices are also supported by wl driver:
- (a5006b5) Device         Vendor ID  Device ID
- (a5006b5) BCM43142 2.4 Ghz     0x14e4	0x4365
- (a5006b5) BCM4331  Dualband    0x14e4	0x4331
- (a5006b5) BCM4360  Dualband    0x14e4	0x43a0
- (a5006b5) BCM4352  Dualband    0x14e4	0x43b1*
- (a5006b5) * Readme.txt states the device ID of BCM4352 is 0x43a0, however,
- (a5006b5) the PCI ID database shows 0x43b1, using the latter.
- (a5006b5) Added aliases for these too.
- (Eugene Shatokhin: 280d905) rmmod can fail (e.g. if the module is not loaded), but it should not stop

* Fri Jul 04 2014 Eugene Shatokhin <eugene.shatokhin@rosalab.ru> 6.30.223.141-7
- (87baa37) Added patches to fix build for the kernels up to 3.15 inclusive

* Fri Jul 04 2014 Eugene Shatokhin <eugene.shatokhin@rosalab.ru> 6.30.223.141-6
- (d1bcac6) Removed the changelog, git should handle that
- (Eugene Shatokhin: 2c662fc) Added notes for the users having BCM4311 adapter
- (Eugene Shatokhin: 2c662fc) BCM4311 is no longer supported by this package (and, it seems, by
- (Eugene Shatokhin: 2c662fc) Broadcom itself). Made this explicit:
- (Eugene Shatokhin: 2c662fc) - listed the supported adapter models in the description
- (Eugene Shatokhin: 2c662fc) - added an "upgrade note" with workarounds to be shown to the users.

* Thu Jan 09 2014 Eugene Shatokhin <eugene.shatokhin@rosalab.ru> 6.30.223.141-5
- (245bf43) Fixed: specified correct files in .abf.yml
- (Eugene Shatokhin: a6ec672) Made version 6.30.223.141 default again

* Wed Dec 11 2013 Eugene Shatokhin <eugene.shatokhin@rosalab.ru> 5.100.82.112-15
- (7157419) Reverted to 5.100.82.112 due to the regression (#2985)

* Wed Dec 11 2013 Eugene Shatokhin <eugene.shatokhin@rosalab.ru> 6.30.223.141-4
- (f4f0490) Make sure the network interface is named wlan%d rather than eth%d
- (f4f0490) The driver sets the format of the name explicitly. Let us make "wlan%d"
- (f4f0490) the default format, same as for other such drivers like brcmfmac, etc.

* Mon Nov 11 2013 Eugene Shatokhin <eugene.shatokhin@rosalab.ru> 6.30.223.141-3
- (44684a6) Make sure 'wl' is not used for BCM4311 adapters
- (44684a6) Seems like 'wl' does not support these. b43+ssb should be used for
- (44684a6) such WiFi adapters instead.
- (44684a6) Details: http://bugs.rosalinux.ru/show_bug.cgi?id=2985#c23

* Tue Oct 29 2013 Eugene Shatokhin <eugene.shatokhin@rosalab.ru> 6.30.223.141-2
- (9c46ebd) Fixed wl-inform-single-bss.patch (it was incorrect for 6.x)

* Mon Oct 07 2013 Eugene Shatokhin <eugene.shatokhin@rosalab.ru> 6.30.223.141-1
- (24b869b) Updated to latest upstream version 6.30.223.141, revisited patches
- (24b869b) Aliases have also been revisited to contain only what Broadcom claims
- (24b869b) to support with this driver.

* Tue Sep 10 2013 Eugene Shatokhin <eugene.shatokhin@rosalab.ru> 5.100.82.112-14
- (406efcc) Fixed error handling in wl_inform_single_bss()
- (406efcc) ieee80211_get_channel() called from wl_inform_single_bss() may return
- (406efcc) NULL if it has found no suitable channel for the given frequency.
- (406efcc) This may happen in some cases, for example, if a laptop hybernated
- (406efcc) within reach of one WiFi access point but woke up within reach of
- (406efcc) another one.
- (406efcc) Before this fix, the driver did not take such cases into account and
- (406efcc) sometimes crashed as a result. Now it should complain to the system
- (406efcc) log but not crash.

* Mon Aug 19 2013 Eugene Shatokhin <eugene.shatokhin@rosalab.ru> 5.100.82.112-13
- (fa1a2c6) Fixed the driver to avoid incorrect calls to kernel API
- (fa1a2c6) Before this fix, the driver called wdev_priv(NULL) in certain conditions,
- (fa1a2c6) which lead to kernel crashes.
- (fa1a2c6) Details: http://bugs.rosalinux.ru/show_bug.cgi?id=2146
- (fa1a2c6) The errors the driver encounters are another story but at least the
- (fa1a2c6) driver is less likely to crash in its error handling paths now.


